//--------------------------------------------------------------------------------------------------
//
// Title       : extender
// Design      : Lab1
// Author      : Steven
// Company     : UW CSE
//
//-------------------------------------------------------------------------------------------------
//
// File        : extender.v
// Generated   : Sat Apr  8 16:06:23 2006
// From        : interface description file
// By          : Itf2Vhdl ver. 1.20
//
//-------------------------------------------------------------------------------------------------
//
// Description : General unit designed to extend an input of one size to output of a different size
//               Supports the following types of extensions:
//                 type = 2'00  Zero Extension
//				   type = 2'01  Sign Extension
//				   type = 2'10  Align Left  ( i.e. shift left until upper input is at upper output )
//                 type = 2'11  Extract Shift Amount ( i.e. return bits [10:6] in bits [4:0] of output)
//-------------------------------------------------------------------------------------------------

module Extender ( CTL ,O ,IN ) /* synthesis syn_black_box */ ;
	
	input [1:0] CTL ;
	input  [15:0] IN ;
	
	output [31:0] O ;
	
	//synopsys translate_off
	
	localparam ZERO_EX = 2'b00;
	localparam SIGN_EX = 2'b01;
	localparam ALIGN_L = 2'b10;
	localparam GET_SHIFT = 2'b11;
	localparam DIFF = 16;
	
	
	
	//}} End of automatically maintained section
	
	// -- Enter your statements here -- //
	assign O = ((CTL == ZERO_EX)? {16'h0000,IN} :
	((CTL == SIGN_EX)? {{DIFF{IN[15]}},IN} :
	((CTL == ALIGN_L)? {IN,16'h0000} : 
	((CTL == GET_SHIFT)? {27'b0,IN[10:6]}:32'bzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz))));
	
	//synopsys translate_on

endmodule
